package com.muyu.goods.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.business.common.domain.Fence;
import com.business.common.domain.FenceGroups;
import com.business.common.domain.Path;
import com.business.common.psvm.Pences;
import com.muyu.goods.mapper.MapMapper;
import com.muyu.goods.service.IMapService;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class MapService implements IMapService {
    @Autowired
    private MapMapper mapMapper;

    @Override
    public List<FenceGroups> selectFenceGroups() {
        List<FenceGroups> fenceGroupsList = mapMapper.selectFenceGroups();
        for (FenceGroups fenceGroups : fenceGroupsList) {
            if (selectFence() == null){
                continue;
            }
            List<Fence> fenceList = selectFence().stream().filter(fa -> fa.getGroupId() == fenceGroups.getGroupsId()).collect(Collectors.toList());
            fenceGroups.setFenceList(fenceList);
        }
        return fenceGroupsList;
    }

    @Override
    public List<Fence> selectFence() {
        List<Fence> fenceList = mapMapper.selectFence();
        return fenceList;
    }

    @Override
    public FenceGroups selectFenceGroupsById(Long carId) {
        List<FenceGroups> groups = selectFenceGroups().stream().filter(car -> car.getCarId() == carId).collect(Collectors.toList());
        return groups.get(0);
    }

    @Override
    public String getSel(Pences pences) {
        System.out.println(pences);
        if (pences.getGroupsId() == null){
            return "数据不全";
        }
        FenceGroups fenceGroups = selectFenceGroups().stream().filter(g -> g.getGroupsId() == pences.getGroupsId()).collect(Collectors.toList()).get(0);
        Fence fence = new Fence();
        fence.setGroupId(pences.getGroupsId());
        List<Path> list = pences.getList();
        String jsonString = JSONArray.toJSONString(list);
        fence.setPolygonPoints(jsonString);
        List<Path> paths = JSONArray.parseArray(jsonString, Path.class);
        fence.setFenceName("围栏"+ (fenceGroups.getFenceList().size()+1));
        int i = mapMapper.indexFence(fence);
        if (i> 0) {
         return "传入电子围栏";
        }
        return "传入电子围栏失败";
    }

    @Override
    public String deleteFence(Long fenceId) {
        int i = mapMapper.deleteFence(fenceId);
        if (i>0){
            return "完成";
        }
        return "无效";
    }

    @Override
    public Fence queryFence(Long fenceId) {
        return mapMapper.queryFence(fenceId);
    }

    @Override
    public String updateFence(Long fenceId) {
        Fence fence = queryFence(fenceId);
        int i = 0;
        if (fence.getStaut().equals("Y")){
            i = mapMapper.updateFence(fenceId,"N");
        }else {
            i = mapMapper.updateFence(fenceId,"Y");
        }
        if (i>0){
            return "成功";
        }
        return "失败";
    }
}
